"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.DynamoManageTable = void 0;

var _utilService = require("../helpers/util-service.js");

var _loggingService = require("../helpers/logging-service.js");

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && Symbol.iterator in Object(iter)) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _createForOfIteratorHelper(o, allowArrayLike) { var it; if (typeof Symbol === "undefined" || o[Symbol.iterator] == null) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = o[Symbol.iterator](); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it["return"] != null) it["return"](); } finally { if (didErr) throw err; } } }; }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var DynamoManageTable = /*#__PURE__*/function () {
  function DynamoManageTable(_ref) {
    var dynamoDb = _ref.dynamoDb,
        secondaryIndexOptions = _ref.secondaryIndexOptions,
        tableFullName = _ref.tableFullName,
        partitionKeyFieldName = _ref.partitionKeyFieldName,
        sortKeyFieldName = _ref.sortKeyFieldName;

    _classCallCheck(this, DynamoManageTable);

    _defineProperty(this, "partitionKeyFieldName", void 0);

    _defineProperty(this, "sortKeyFieldName", void 0);

    _defineProperty(this, "dynamoDb", void 0);

    _defineProperty(this, "tableFullName", void 0);

    _defineProperty(this, "secondaryIndexOptions", void 0);

    this.dynamoDb = dynamoDb;
    this.tableFullName = tableFullName;
    this.partitionKeyFieldName = partitionKeyFieldName;
    this.sortKeyFieldName = sortKeyFieldName;
    this.secondaryIndexOptions = secondaryIndexOptions;
  }

  _createClass(DynamoManageTable, [{
    key: "_getLocalVariables",
    value: function _getLocalVariables() {
      return {
        partitionKeyFieldName: this.partitionKeyFieldName,
        sortKeyFieldName: this.sortKeyFieldName,
        //
        tableFullName: this.tableFullName,
        secondaryIndexOptions: this.secondaryIndexOptions
      };
    }
  }, {
    key: "_dynamoDb",
    value: function _dynamoDb() {
      return this.dynamoDb();
    }
  }, {
    key: "allGetListOfTablesNamesOnlineBase",
    value: function () {
      var _allGetListOfTablesNamesOnlineBase = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
        var params, listOfTables;
        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                params = {
                  Limit: 99
                };
                _context.next = 3;
                return this._dynamoDb().listTables(params).promise();

              case 3:
                listOfTables = _context.sent;
                return _context.abrupt("return", listOfTables === null || listOfTables === void 0 ? void 0 : listOfTables.TableNames);

              case 5:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function allGetListOfTablesNamesOnlineBase() {
        return _allGetListOfTablesNamesOnlineBase.apply(this, arguments);
      }

      return allGetListOfTablesNamesOnlineBase;
    }()
  }, {
    key: "allTableSettingUpdateTTLBase",
    value: function () {
      var _allTableSettingUpdateTTLBase = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(_ref2) {
        var attrName, isEnabled, _this$_getLocalVariab, tableFullName, params, result;

        return regeneratorRuntime.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                attrName = _ref2.attrName, isEnabled = _ref2.isEnabled;
                _this$_getLocalVariab = this._getLocalVariables(), tableFullName = _this$_getLocalVariab.tableFullName;
                params = {
                  TableName: tableFullName,
                  TimeToLiveSpecification: {
                    AttributeName: attrName,
                    Enabled: isEnabled
                  }
                };
                _context2.next = 5;
                return this._dynamoDb().updateTimeToLive(params).promise();

              case 5:
                result = _context2.sent;

                if (!(result === null || result === void 0 ? void 0 : result.TimeToLiveSpecification)) {
                  _context2.next = 8;
                  break;
                }

                return _context2.abrupt("return", result.TimeToLiveSpecification);

              case 8:
                return _context2.abrupt("return", null);

              case 9:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function allTableSettingUpdateTTLBase(_x) {
        return _allTableSettingUpdateTTLBase.apply(this, arguments);
      }

      return allTableSettingUpdateTTLBase;
    }()
  }, {
    key: "allGetTableInfoBase",
    value: function () {
      var _allGetTableInfoBase = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee3() {
        var _result$Table, _this$_getLocalVariab2, tableFullName, params, result;

        return regeneratorRuntime.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                _context3.prev = 0;
                _this$_getLocalVariab2 = this._getLocalVariables(), tableFullName = _this$_getLocalVariab2.tableFullName;
                params = {
                  TableName: tableFullName
                };
                _context3.next = 5;
                return this._dynamoDb().describeTable(params).promise();

              case 5:
                result = _context3.sent;

                if (!((result === null || result === void 0 ? void 0 : (_result$Table = result.Table) === null || _result$Table === void 0 ? void 0 : _result$Table.TableName) === tableFullName)) {
                  _context3.next = 8;
                  break;
                }

                return _context3.abrupt("return", result.Table);

              case 8:
                return _context3.abrupt("return", null);

              case 11:
                _context3.prev = 11;
                _context3.t0 = _context3["catch"](0);

                _loggingService.LoggingService.log({
                  "@allGetTableInfoBase": "",
                  error: _context3.t0 === null || _context3.t0 === void 0 ? void 0 : _context3.t0.message
                });

                return _context3.abrupt("return", null);

              case 15:
              case "end":
                return _context3.stop();
            }
          }
        }, _callee3, this, [[0, 11]]);
      }));

      function allGetTableInfoBase() {
        return _allGetTableInfoBase.apply(this, arguments);
      }

      return allGetTableInfoBase;
    }()
  }, {
    key: "allCheckTableExistsBase",
    value: function () {
      var _allCheckTableExistsBase = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee4() {
        var result;
        return regeneratorRuntime.wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                _context4.next = 2;
                return this.allGetTableInfoBase();

              case 2:
                result = _context4.sent;

                if (result) {
                  _context4.next = 5;
                  break;
                }

                return _context4.abrupt("return", false);

              case 5:
                if (result === null || result === void 0 ? void 0 : result.GlobalSecondaryIndexes) {// console.log(JSON.stringify({ tableInfo: result }, null, 2));
                }

                return _context4.abrupt("return", true);

              case 7:
              case "end":
                return _context4.stop();
            }
          }
        }, _callee4, this);
      }));

      function allCheckTableExistsBase() {
        return _allCheckTableExistsBase.apply(this, arguments);
      }

      return allCheckTableExistsBase;
    }()
  }, {
    key: "_allUpdateGlobalSecondaryIndexBase",
    value: function () {
      var _allUpdateGlobalSecondaryIndexBase2 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee5(_ref3) {
        var _this = this;

        var secondaryIndexOptions, existingTableInfo, _existingTableInfo$Gl, existingIndexNames, staledIndexNames, allIndexNames, newSecondaryIndexOptions, updateResults, canUpdate, _this$_getLocalVariab3, tableFullName, indexCount, _iterator, _step, _loop, _indexCount, _iterator2, _step2, _params$GlobalSeconda2, indexName, params, result, label;

        return regeneratorRuntime.wrap(function _callee5$(_context6) {
          while (1) {
            switch (_context6.prev = _context6.next) {
              case 0:
                secondaryIndexOptions = _ref3.secondaryIndexOptions, existingTableInfo = _ref3.existingTableInfo;
                _context6.prev = 1;
                existingIndexNames = [];
                staledIndexNames = [];
                allIndexNames = [];
                newSecondaryIndexOptions = [];
                updateResults = [];

                if (existingTableInfo === null || existingTableInfo === void 0 ? void 0 : (_existingTableInfo$Gl = existingTableInfo.GlobalSecondaryIndexes) === null || _existingTableInfo$Gl === void 0 ? void 0 : _existingTableInfo$Gl.length) {
                  existingTableInfo === null || existingTableInfo === void 0 ? void 0 : existingTableInfo.GlobalSecondaryIndexes.forEach(function (indexInfo) {
                    if (indexInfo.IndexName) {
                      existingIndexNames.push(indexInfo.IndexName);
                    }
                  });
                }

                secondaryIndexOptions === null || secondaryIndexOptions === void 0 ? void 0 : secondaryIndexOptions.forEach(function (newIndexInfo) {
                  allIndexNames.push(newIndexInfo.indexName);
                  var indexExists = existingIndexNames.includes(newIndexInfo.indexName);

                  if (!indexExists) {
                    newSecondaryIndexOptions.push(newIndexInfo);
                  }
                });
                existingIndexNames.forEach(function (indexName) {
                  var existsInList = allIndexNames.includes(indexName);

                  if (!existsInList) {
                    staledIndexNames.push(indexName);
                  }
                });

                if (newSecondaryIndexOptions.length || staledIndexNames.length) {
                  _context6.next = 12;
                  break;
                }

                return _context6.abrupt("return", null);

              case 12:
                canUpdate = false;
                _this$_getLocalVariab3 = this._getLocalVariables(), tableFullName = _this$_getLocalVariab3.tableFullName;

                _loggingService.LoggingService.log({
                  secondaryIndexOptions: secondaryIndexOptions.length,
                  newSecondaryIndexOptions: newSecondaryIndexOptions.length,
                  staledIndexNames: staledIndexNames.length,
                  tableName: tableFullName
                });

                if (!newSecondaryIndexOptions.length) {
                  _context6.next = 34;
                  break;
                }

                canUpdate = true;
                indexCount = 0;
                _iterator = _createForOfIteratorHelper(newSecondaryIndexOptions);
                _context6.prev = 19;
                _loop = /*#__PURE__*/regeneratorRuntime.mark(function _loop() {
                  var indexOption, params, creationParams, indexName, result, label;
                  return regeneratorRuntime.wrap(function _loop$(_context5) {
                    while (1) {
                      switch (_context5.prev = _context5.next) {
                        case 0:
                          indexOption = _step.value;
                          params = {
                            TableName: tableFullName,
                            GlobalSecondaryIndexUpdates: []
                          };
                          indexCount++;
                          creationParams = _this._getGlobalSecondaryIndexCreationParams({
                            secondaryIndexOptions: [indexOption]
                          });
                          indexName = creationParams.xGlobalSecondaryIndex[0].IndexName;
                          params.AttributeDefinitions = _toConsumableArray(creationParams.xAttributeDefinitions);
                          creationParams.xGlobalSecondaryIndex.forEach(function (gsi) {
                            var _params$GlobalSeconda;

                            (_params$GlobalSeconda = params.GlobalSecondaryIndexUpdates) === null || _params$GlobalSeconda === void 0 ? void 0 : _params$GlobalSeconda.push({
                              Create: _objectSpread({}, gsi)
                            });
                          });
                          _context5.next = 9;
                          return _this._dynamoDb().updateTable(params).promise();

                        case 9:
                          result = _context5.sent;

                          if (result === null || result === void 0 ? void 0 : result.TableDescription) {
                            updateResults.push(result === null || result === void 0 ? void 0 : result.TableDescription);
                          }

                          _loggingService.LoggingService.log(["Creating Index: '".concat(indexName, "'"), "on table '".concat(tableFullName, "' started:"), new Date().toTimeString()].join(" "));

                          if (!(indexCount !== newSecondaryIndexOptions.length)) {
                            _context5.next = 18;
                            break;
                          }

                          label = "Created Index '".concat(indexName, "'");
                          console.time(label);
                          _context5.next = 17;
                          return _utilService.UtilService.waitUntilMunites(5);

                        case 17:
                          console.timeEnd(label);

                        case 18:
                        case "end":
                          return _context5.stop();
                      }
                    }
                  }, _loop);
                });

                _iterator.s();

              case 22:
                if ((_step = _iterator.n()).done) {
                  _context6.next = 26;
                  break;
                }

                return _context6.delegateYield(_loop(), "t0", 24);

              case 24:
                _context6.next = 22;
                break;

              case 26:
                _context6.next = 31;
                break;

              case 28:
                _context6.prev = 28;
                _context6.t1 = _context6["catch"](19);

                _iterator.e(_context6.t1);

              case 31:
                _context6.prev = 31;

                _iterator.f();

                return _context6.finish(31);

              case 34:
                if (!staledIndexNames.length) {
                  _context6.next = 69;
                  break;
                }

                if (!canUpdate) {
                  _context6.next = 38;
                  break;
                }

                _context6.next = 38;
                return _utilService.UtilService.waitUntilMunites(4);

              case 38:
                canUpdate = true;
                _indexCount = 0;
                _iterator2 = _createForOfIteratorHelper(staledIndexNames);
                _context6.prev = 41;

                _iterator2.s();

              case 43:
                if ((_step2 = _iterator2.n()).done) {
                  _context6.next = 61;
                  break;
                }

                indexName = _step2.value;
                params = {
                  TableName: tableFullName,
                  GlobalSecondaryIndexUpdates: []
                };
                _indexCount++;
                (_params$GlobalSeconda2 = params.GlobalSecondaryIndexUpdates) === null || _params$GlobalSeconda2 === void 0 ? void 0 : _params$GlobalSeconda2.push({
                  Delete: {
                    IndexName: indexName
                  }
                });
                _context6.next = 50;
                return this._dynamoDb().updateTable(params).promise();

              case 50:
                result = _context6.sent;

                if (result === null || result === void 0 ? void 0 : result.TableDescription) {
                  updateResults.push(result === null || result === void 0 ? void 0 : result.TableDescription);
                }

                _loggingService.LoggingService.log(["Deleting Index: '".concat(indexName, "'"), "on table '".concat(tableFullName, "' started:"), new Date().toTimeString()].join(" "));

                if (!(_indexCount !== staledIndexNames.length)) {
                  _context6.next = 59;
                  break;
                }

                label = "Deleted Index '".concat(indexName, "'");
                console.time(label);
                _context6.next = 58;
                return _utilService.UtilService.waitUntilMunites(1);

              case 58:
                console.timeEnd(label);

              case 59:
                _context6.next = 43;
                break;

              case 61:
                _context6.next = 66;
                break;

              case 63:
                _context6.prev = 63;
                _context6.t2 = _context6["catch"](41);

                _iterator2.e(_context6.t2);

              case 66:
                _context6.prev = 66;

                _iterator2.f();

                return _context6.finish(66);

              case 69:
                if (canUpdate) {
                  _context6.next = 71;
                  break;
                }

                return _context6.abrupt("return", null);

              case 71:
                if (!updateResults.length) {
                  _context6.next = 74;
                  break;
                }

                console.log({
                  "@allCreateGlobalSecondaryIndexBase": "",
                  updateResults: updateResults
                });
                return _context6.abrupt("return", updateResults);

              case 74:
                return _context6.abrupt("return", null);

              case 77:
                _context6.prev = 77;
                _context6.t3 = _context6["catch"](1);

                _loggingService.LoggingService.log({
                  "@allCreateGlobalSecondaryIndexBase": "",
                  error: _context6.t3 === null || _context6.t3 === void 0 ? void 0 : _context6.t3.message
                });

                return _context6.abrupt("return", null);

              case 81:
              case "end":
                return _context6.stop();
            }
          }
        }, _callee5, this, [[1, 77], [19, 28, 31, 34], [41, 63, 66, 69]]);
      }));

      function _allUpdateGlobalSecondaryIndexBase(_x2) {
        return _allUpdateGlobalSecondaryIndexBase2.apply(this, arguments);
      }

      return _allUpdateGlobalSecondaryIndexBase;
    }()
  }, {
    key: "allCreateTableIfNotExistsBase",
    value: function () {
      var _allCreateTableIfNotExistsBase = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee6() {
        var _this$_getLocalVariab4, secondaryIndexOptions, existingTableInfo, _existingTableInfo$Gl2;

        return regeneratorRuntime.wrap(function _callee6$(_context7) {
          while (1) {
            switch (_context7.prev = _context7.next) {
              case 0:
                _this$_getLocalVariab4 = this._getLocalVariables(), secondaryIndexOptions = _this$_getLocalVariab4.secondaryIndexOptions;
                _context7.next = 3;
                return this.allGetTableInfoBase();

              case 3:
                existingTableInfo = _context7.sent;

                if (!existingTableInfo) {
                  _context7.next = 14;
                  break;
                }

                if (!(secondaryIndexOptions === null || secondaryIndexOptions === void 0 ? void 0 : secondaryIndexOptions.length)) {
                  _context7.next = 10;
                  break;
                }

                _context7.next = 8;
                return this._allUpdateGlobalSecondaryIndexBase({
                  secondaryIndexOptions: secondaryIndexOptions,
                  existingTableInfo: existingTableInfo
                });

              case 8:
                _context7.next = 13;
                break;

              case 10:
                if (!((_existingTableInfo$Gl2 = existingTableInfo.GlobalSecondaryIndexes) === null || _existingTableInfo$Gl2 === void 0 ? void 0 : _existingTableInfo$Gl2.length)) {
                  _context7.next = 13;
                  break;
                }

                _context7.next = 13;
                return this._allUpdateGlobalSecondaryIndexBase({
                  secondaryIndexOptions: [],
                  existingTableInfo: existingTableInfo
                });

              case 13:
                return _context7.abrupt("return", null);

              case 14:
                _context7.next = 16;
                return this.allCreateTableBase();

              case 16:
                return _context7.abrupt("return", _context7.sent);

              case 17:
              case "end":
                return _context7.stop();
            }
          }
        }, _callee6, this);
      }));

      function allCreateTableIfNotExistsBase() {
        return _allCreateTableIfNotExistsBase.apply(this, arguments);
      }

      return allCreateTableIfNotExistsBase;
    }()
  }, {
    key: "_getGlobalSecondaryIndexCreationParams",
    value: function _getGlobalSecondaryIndexCreationParams(_ref4) {
      var secondaryIndexOptions = _ref4.secondaryIndexOptions;

      var _this$_getLocalVariab5 = this._getLocalVariables(),
          tableFullName = _this$_getLocalVariab5.tableFullName;

      var params = {
        KeySchema: [],
        //  make linter happy
        AttributeDefinitions: [],
        TableName: tableFullName,
        GlobalSecondaryIndexes: []
      };
      var attributeDefinitionsNameList = [];
      secondaryIndexOptions.forEach(function (sIndex) {
        var _projectionFields, _params$GlobalSeconda3;

        var indexName = sIndex.indexName,
            keyFieldName = sIndex.keyFieldName,
            sortFieldName = sIndex.sortFieldName,
            dataType = sIndex.dataType,
            projectionFieldsInclude = sIndex.projectionFieldsInclude; //

        var _keyFieldName = keyFieldName;
        var _sortFieldName = sortFieldName;

        if (!attributeDefinitionsNameList.includes(_keyFieldName)) {
          var _params$AttributeDefi;

          attributeDefinitionsNameList.push(_keyFieldName);
          params === null || params === void 0 ? void 0 : (_params$AttributeDefi = params.AttributeDefinitions) === null || _params$AttributeDefi === void 0 ? void 0 : _params$AttributeDefi.push({
            AttributeName: _keyFieldName,
            AttributeType: dataType
          });
        }

        if (!attributeDefinitionsNameList.includes(_sortFieldName)) {
          var _params$AttributeDefi2;

          attributeDefinitionsNameList.push(_sortFieldName);
          params === null || params === void 0 ? void 0 : (_params$AttributeDefi2 = params.AttributeDefinitions) === null || _params$AttributeDefi2 === void 0 ? void 0 : _params$AttributeDefi2.push({
            AttributeName: _sortFieldName,
            AttributeType: dataType
          });
        }

        var projectionFields = projectionFieldsInclude || [];
        var projectionType = "ALL";

        if ((_projectionFields = projectionFields) === null || _projectionFields === void 0 ? void 0 : _projectionFields.length) {
          // remove frimary keys from include
          projectionFields = projectionFields.filter(function (field) {
            return field !== _keyFieldName && field !== _sortFieldName;
          });

          if (projectionFields.length === 0) {
            // only keys was projceted
            projectionType = "KEYS_ONLY";
          } else {
            // only keys was projceted
            projectionType = "INCLUDE";
          }
        }

        (_params$GlobalSeconda3 = params.GlobalSecondaryIndexes) === null || _params$GlobalSeconda3 === void 0 ? void 0 : _params$GlobalSeconda3.push({
          IndexName: indexName,
          Projection: {
            ProjectionType: projectionType,
            NonKeyAttributes: projectionType === "INCLUDE" ? projectionFields : undefined
          },
          KeySchema: [{
            AttributeName: _keyFieldName,
            KeyType: "HASH"
          }, {
            AttributeName: _sortFieldName,
            KeyType: "RANGE"
          }]
        });
      });
      return {
        xAttributeDefinitions: params.AttributeDefinitions || [],
        xGlobalSecondaryIndex: params.GlobalSecondaryIndexes || []
      };
    }
  }, {
    key: "allCreateTableBase",
    value: function () {
      var _allCreateTableBase = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee7() {
        var _this$_getLocalVariab6, partitionKeyFieldName, sortKeyFieldName, tableFullName, secondaryIndexOptions, params, _creationParams$xAttr, creationParams, existAttrDefNames, result;

        return regeneratorRuntime.wrap(function _callee7$(_context8) {
          while (1) {
            switch (_context8.prev = _context8.next) {
              case 0:
                _this$_getLocalVariab6 = this._getLocalVariables(), partitionKeyFieldName = _this$_getLocalVariab6.partitionKeyFieldName, sortKeyFieldName = _this$_getLocalVariab6.sortKeyFieldName, tableFullName = _this$_getLocalVariab6.tableFullName, secondaryIndexOptions = _this$_getLocalVariab6.secondaryIndexOptions;
                params = {
                  AttributeDefinitions: [{
                    AttributeName: partitionKeyFieldName,
                    AttributeType: "S"
                  }, {
                    AttributeName: sortKeyFieldName,
                    AttributeType: "S"
                  }],
                  KeySchema: [{
                    AttributeName: partitionKeyFieldName,
                    KeyType: "HASH"
                  }, {
                    AttributeName: sortKeyFieldName,
                    KeyType: "RANGE"
                  }],
                  BillingMode: "PAY_PER_REQUEST",
                  TableName: tableFullName
                };
                params.Tags = [{
                  Key: "tablePrefix",
                  Value: tableFullName
                }, {
                  Key: "DDBTableGroupKey-".concat(tableFullName),
                  Value: tableFullName
                }];

                if (secondaryIndexOptions === null || secondaryIndexOptions === void 0 ? void 0 : secondaryIndexOptions.length) {
                  creationParams = this._getGlobalSecondaryIndexCreationParams({
                    secondaryIndexOptions: secondaryIndexOptions
                  });

                  if ((_creationParams$xAttr = creationParams.xAttributeDefinitions) === null || _creationParams$xAttr === void 0 ? void 0 : _creationParams$xAttr.length) {
                    existAttrDefNames = params.AttributeDefinitions.map(function (def) {
                      return def.AttributeName;
                    });
                    creationParams.xAttributeDefinitions.forEach(function (def) {
                      var alreadyDefined = existAttrDefNames.includes(def.AttributeName);

                      if (!alreadyDefined) {
                        params.AttributeDefinitions.push(def);
                      }
                    });
                  }

                  params.GlobalSecondaryIndexes = _toConsumableArray(creationParams.xGlobalSecondaryIndex);
                }

                _loggingService.LoggingService.log({
                  "@allCreateTableBase, table: ": tableFullName
                });

                _context8.next = 7;
                return this._dynamoDb().createTable(params).promise();

              case 7:
                result = _context8.sent;

                if (!(result === null || result === void 0 ? void 0 : result.TableDescription)) {
                  _context8.next = 11;
                  break;
                }

                _loggingService.LoggingService.log(["@allCreateTableBase,", "Created table: '".concat(result === null || result === void 0 ? void 0 : result.TableDescription.TableName, "'"), new Date().toTimeString()].join(" "));

                return _context8.abrupt("return", result.TableDescription);

              case 11:
                return _context8.abrupt("return", null);

              case 12:
              case "end":
                return _context8.stop();
            }
          }
        }, _callee7, this);
      }));

      function allCreateTableBase() {
        return _allCreateTableBase.apply(this, arguments);
      }

      return allCreateTableBase;
    }()
  }, {
    key: "allDeleteGlobalSecondaryIndexBase",
    value: function () {
      var _allDeleteGlobalSecondaryIndexBase = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee8(indexName) {
        var _this$_getLocalVariab7, tableFullName, params, result;

        return regeneratorRuntime.wrap(function _callee8$(_context9) {
          while (1) {
            switch (_context9.prev = _context9.next) {
              case 0:
                _this$_getLocalVariab7 = this._getLocalVariables(), tableFullName = _this$_getLocalVariab7.tableFullName;
                params = {
                  TableName: tableFullName,
                  GlobalSecondaryIndexUpdates: [{
                    Delete: {
                      IndexName: indexName
                    }
                  }]
                };
                _context9.next = 4;
                return this._dynamoDb().updateTable(params).promise();

              case 4:
                result = _context9.sent;

                if (!(result === null || result === void 0 ? void 0 : result.TableDescription)) {
                  _context9.next = 7;
                  break;
                }

                return _context9.abrupt("return", result.TableDescription);

              case 7:
                return _context9.abrupt("return", null);

              case 8:
              case "end":
                return _context9.stop();
            }
          }
        }, _callee8, this);
      }));

      function allDeleteGlobalSecondaryIndexBase(_x3) {
        return _allDeleteGlobalSecondaryIndexBase.apply(this, arguments);
      }

      return allDeleteGlobalSecondaryIndexBase;
    }()
  }]);

  return DynamoManageTable;
}();

exports.DynamoManageTable = DynamoManageTable;